/*
 * This code was contributed by Oliver Schmidt 
 * and is maintained by Steve Nickolas as part of the overall MoDapple project
 * (it is not an actual part of the MoDapple *program*).
 */

#include <stdint.h>
#include "vice.h"
#include "cs8900.h"

__declspec(dllexport) uint32_t mod_type=0x544F4C53;
__declspec(dllexport) uint8_t *mod_name="Uthernet";
__declspec(dllexport) uint8_t *mod_pref="cs8900a";
__declspec(dllexport) uint8_t *mod_vers="0.01";
__declspec(dllexport) uint8_t *mod_copr="Copyright 2016 Oliver Schmidt\n\
Based on VICE code copyright 2016 Spiro Trikaliotis, Andreas Boose and\n\
Christian Vogelgsang.\n\
\n\
pcap interface\n\
  Copyright 1990-1997 The Regents of the University of California\n\
  Copyright 2002-2005 Netgroup, Politecnico di Torino (Italy)\n\
  Copyright 2005-2009 CACE Technologies Inc. Davis (California)\n\
\n\
This module is free software; you can redistribute it and/or modify\n\
it under the terms of the GNU General Public License as published by\n\
the Free Software Foundation; either version 2 of the License, or\n\
(at your option) any later version.";

__declspec(dllexport) uint8_t *cs8900a_preload_name="";
__declspec(dllexport) uint16_t cs8900a_preload_size=0;
__declspec(dllexport) uint8_t *cs8900a_preload_ptr=0;

__declspec(dllexport) void cs8900a_write16 (uint16_t a, uint8_t v)
{
 cs8900_store(a&0x0F, v);
}

__declspec(dllexport) void cs8900a_write256 (uint16_t a, uint8_t v)
{
}

__declspec(dllexport) void cs8900a_write2048 (uint16_t a, uint8_t v)
{
}

__declspec(dllexport) uint8_t cs8900a_read16 (uint16_t a)
{
 return cs8900_read(a&0x0F);
}

__declspec(dllexport) uint8_t cs8900a_read256 (uint16_t a)
{
 return 0;
}

__declspec(dllexport) uint8_t cs8900a_read2048 (uint16_t a)
{
 return 0;
}

__declspec(dllexport) int16_t cs8900a_override_wr (uint16_t a, uint8_t v)
{
 return -1; /* we don't do this. */
}

__declspec(dllexport) int16_t cs8900a_override_rd (uint16_t a)
{
 return -1; /* we don't do this. */
}

__declspec(dllexport) int cs8900a_reset (void)
{
 cs8900_reset();
 return 0;
}

__declspec(dllexport) int cs8900a_loop (uint32_t cycles)
{
 return 0;
}

__declspec(dllexport) int cs8900a_init (uint8_t slot)
{
 return cs8900_init() || cs8900_activate("");
}

__declspec(dllexport) int cs8900a_deinit (void)
{
 cs8900_deactivate();
 cs8900_shutdown();
 return 0;
}

__declspec(dllexport) void cs8900a_config (void)
{
}
