#include <stdio.h>

void rwts_read (FILE *file, char *buf, unsigned char t, unsigned char s)
{
 long b;

 b=t;
 b<<=4;
 b+=s;
 b<<=8;

 fseek(file,b,SEEK_SET);
 fread(buf, 1, 256, file);
}

int catalog (char *filename)
{
 FILE *file;
 char buf[256];
 int t, s;

 file=fopen(filename,"rb");
 if (!file)
 {
  perror(filename);
  return 1;
 }

 rwts_read(file, buf, 17, 0); /* VTOC */

 t=buf[0x34];
 s=buf[0x35];
 if ((t!=35)||((s!=13)&&(s!=16)))
 {
  fprintf (stderr, "Does not appear to be a DOS 3.x disk.\n"
                   "Tracks =%03d (should be 35)\nSectors=%03d (should be 13/16)\n", t, s );
  return -1;
 }

 t=buf[1];
 s=buf[2];

 printf ("\nDISK VOLUME %03d\n\n", buf[0x06]);

 while (t)
 {
  int travel;

  rwts_read(file, buf, t, s);

  t=buf[1];
  s=buf[2];

  for (travel=0; travel<7; travel++)
  {
   char *ptr;

   ptr=&(buf[0x0B+(0x23*travel)]);
   if (((*ptr)!=0xFF)&&(*ptr))
   {
    int travel2;

    printf ("%c",(ptr[2]&0x80)?'*':' ');
    switch (ptr[2]&0x7F)
    {
     case 0x40:
      printf ("O");
      break;
     case 0x20:
      printf ("U");
      break;
     case 0x10:
      printf ("R");
      break;
     case 0x08:
      printf ("S");
      break;
     case 0x04:
      printf ("B");
      break;
     case 0x02:
      printf ("A");
      break;
     case 0x01:
      printf ("I");
      break;
     case 0x00:
      printf ("T");
      break;
     default:
      printf ("?");
      break;
    }

    printf (" %03d ", ptr[0x21]); /* note that this is actually a WORD
                                     but DOS only displays the low byte */

    for (travel2=3; travel2<33; travel2++)
    { 
     printf ("%c", ptr[travel2]&127);
    }

    printf ("\n");
   }
  }
 }

 fclose(file);
 return 0;
}

int main (int argc, char **argv)
{
 int e, t;

 e=0;
 
 if (argc==1)
 {
  fprintf (stderr, "usage: %s filename.dsk [...]\n", argv[0]);
  return -1;
 }

 if (argc==2)
 {
  e=catalog (argv[1]);
  return e;
 }

 for (t=1; t<argc; t++)
 {
  printf ("--Filename: %s--\n", argv[t]);
  e+=catalog (argv[t]);
  printf ("\n");
 }
 printf ("--End of listing--\n");
 return e;
}
